﻿; vim:foldcolumn=0:autoindent:autochdir:scrolloff=0:nocursorline:nocursorcolumn:scrolljump=0:nostartofline:nowrap:nobackup:noundofile:noswapfile:virtualedit=:

; +---------------------------------------------------------------------------+
; |                                                                           |
; |  retroReader.ahk                                                          | 
; |  -------------------------------------------------------                  |
; |  Created: ~ beg 2016                                                      |
; |  Last Edited: 11 Apr 2018                                                 |
; |                                                                           |
; |  Script Purpose:                                                          |
; |  - allow The User to quickly scroll up and down a Document using Reader   |   
; |    The User is envisaged to use                                           |
; |    * The Scroll Wheel                                                     |
; |    for achieve this purpose                                               |
; |  - make the provision of Visual Crosshair                                 |
; |    The User has access to easily turn easily this on and off using the    |
; |    Right Mouse button                                                     |
; |  - make provision of 'Bmw Animations' the user can quickly can quickly    |
; |    switch on/off using The Middle Mouse Button                            |
; |  - allow The User to quickly quit The Script by pressing Q                |
; |                                                                           |
; +---------------------------------------------------------------------------+

#include retroReaderUtils.ahk
#include retroReaderAniGif.ahk

#NoEnv  ; Recommended for performance and compatibility with future AutoHotkey releases.
#Persistent

; if not seems to go for some weird thing like control or something 
CoordMode, Mouse, Screen

; #Warn  ; Enable warnings to assist with detecting common errors.
SendMode Input  ; Recommended for new scripts due to its superior speed and reliability.
SetWorkingDir %A_ScriptDir%  ; Ensures a consistent starting directory.

Menu, Tray, Icon, retroReader.ico

SetTitleMatchMode,2

SystemCursor("Off")

bScrollStarted := 0
b_scrollingNormal := 0
b_taskbarHidden = 0
bTestOK := 0
b_scanOn := 0
b_toggHighColour := 0
n_scanlineClr := 0
n_scanlineClrMax := 7
b_iRepeat := 0
n_bmwPanelsClr := 4
n_BMWrotationCounter := 0
n_crosshairPaintAcross_bmpWidth := 200
n_crosshairPaintAcross_bmpHeight := 3
n_crosshairPaintAcross_height := 3
n_crosshairPaintAcross_y := A_ScreenHeight//2
n_crosshairPaintDown_width = 3
n_crosshairPaintDown_bmpWidth := 3
n_crosshairPaintDown_bmpHeight := 200
n_crosshairPaintDown_x := A_ScreenWidth//2
b_crossOn = 0
b_crossApparentlyOffButReallyStillOnscreen = 0
n_crossApparentlyOffButReallyStillOnscreen_x = 0
n_crossApparentlyOffButReallyStillOnscreen_y = 0
n_crosshairDelay = 10
n_crosshairMinTransparency = 40
n_crosshairSP1 = 1
n_crosshairSP2 = 2
n_crosshairSP3 = 3
n_crosshairSP4 = 5
K_SCROLLSPEEDMAX = 7
K_SCROLLSPEEDALMOSTMAX = 5
K_SCROLLSPEEDALMOSTSLOW = 3
K_SCROLLSPEEDSLOW = 1
K_SCANHEIGHT := 21
K_SCANWIDTH = 478
K_SCANMIDDLEOFLEFTHAND := K_SCANWIDTH-(K_SCANWIDTH//2)-(K_SCANWIDTH//4)-2
K_SCANDISPLACEMENT_X = -238
K_SCANDISPLACEMENT_Y = 48
K_MESSAGETEXT_XPOS = 186
n_mouseJoyWheelCounterInterrupt = 0
n_mouseJoyWheelCounterinterruptFreq = 2
n_mouseJoyWheelCounter = 50
b_wheelConfirmedUp = 0
b_wheelConfirmedDown = 0
n_mouseMovementConcern = 0

;a few defaults
; it looks like these were just created for the animation/time strip
; runs ok 6 may 2018  1317 hrs with default comment out
; K_HALFSCREENWIDTH := A_ScreenWidth//2
; K_HALFSCREENHEIGHT := A_ScreenHeight//2
; K_TILLB4HALFWIDTH_TX := A_ScreenWidth//2-172
; K_TILLAFHALFWIDTH_TX := A_ScreenWidth//2+188
; K_QUARTERSCREENHEIGHT := A_ScreenHeight//4
; K_THREEQUARTERSCREENHEIGHT := K_QUARTERSCREENHEIGHT*3
; K_MAXANIMWIDTH = 204

midScreenY := A_ScreenHeight//2

K_BMWTRANSPARENCY := 25

; auto-cancel
; to stop interfering with the reader screen all the widgets
; are removed when you scroll with the mouse wheel
; this tracks whether reader needs to be given focus again
b_scanCancel := 0
b_crossCancel := 0

; reminder of keys instruction / calibrate
n_userBeingGivenInstruction = 0
b_calibrationIsActiveAndOngoing = 0
b_spacePushedToForceTerminateAvatarGuy = 0

;graphics cute animations
n_anim := 0
n_animsMax := 30
n_animShowCountdown := 0
n_animShowCountdownMax := 1
h_aniGifRetro = 0
b_animShuffleHoldOn = 0

a_shuffleRecord := Object()
n_it = 0
while (n_it < n_animsMax)
{
	a_shuffleRecord[n_it] := 0
	n_it += 1
}
Random, n_anim, 0, %n_animsMax%

;CONSTANTS
;  for crosshair removal
;  VERTICAL vs. HORIZONTAL
K_YAXIS := 100
K_XAXIS := 101

;  RANGE AVERIGUATION
K_GT := 300
K_GTE := 301
K_LT := 302
K_LTE := 303

; DIRECTION
K_TEXTFLOWINGDOWN := 400
K_TEXTFLOWINGUP := 401

;  gui1 vertical axis - line painted down the screen
Gui,+ToolWindow
Gui,Color, FF0000
Gui,Show,X0 Y0 H100 Y100
WinSet, AlwaysOnTop, On, A
WinSet, Style, -0xC00000, A
WinGet, n_crosshairPaintDown_id, ID, A
Gui,Show,X%n_crosshairPaintDown_x% Y0 H%A_ScreenHeight% W%n_crosshairPaintDown_width%
Gui,+Hwndhwnd_PD
Gui,Hide

;  gui2 horizontal axis - line painted across the screen
Gui,New
Gui,2:+ToolWindow
Gui,2:Color, FF0000
Gui,2:Show,X0 Y0 H100 Y100
WinSet, AlwaysOnTop, On, A
WinSet, Style, -0xC00000, A
WinGet, n_crosshairPaintAcross_id, ID, A
Gui,2:Show,X0 Y%n_crosshairPaintAcross_y% H%n_crosshairPaintAcross_height% W%A_ScreenWidth%
Gui,2:+Hwndhwnd_PA
Gui,2:Hide

;background 'sheet'
Gui,New
Gui,3:+ToolWindow
Gui,3:Color,EDF171
Gui,3:Show,X0 Y0 H100 Y100
WinSet, Style, -0xC00000, A
Gui,3:Show,X0 Y0 H%A_ScreenHeight% W%A_ScreenWidth%
Gui,3:Hide
WinActivate,Adobe
Sleep,800

;scan line panel
Gui,New
Gui,4:+ToolWindow
scanY0 := 100
s_scanLineClrCode := getScanLineClrCode(n_scanlineClr)
s_scanLineClrCodewith0x = 0x%s_scanLineClrCode%
Gui,4:Color,%s_scanLineClrCodewith0x%
Gui,4:Font,cYellow
; ^^ notice that you need to specify this option before you Gui,Add,Text
Gui,4:Add,Text,vMyText W340 H18 X%K_MESSAGETEXT_XPOS% Y1 Center,wont be visible very long
Gui,4:Show,X0 Y0 H200 W200
WinSet, Style, -0xC00000, A
; doesn't quite give curves everywhere, only top left
;WinSet, Region, 2-2 W%K_SCANWIDTH% H%K_SCANHEIGHT% R2-2, A
WinGet, scanlinePanel_id, ID, A
Gui,4:Show,X0 Y%scanY0% H%K_SCANHEIGHT% W%K_SCANWIDTH%
Gui,4:+Hwndhwnd_retro
h_aniGifRetro := AniGif_CreateControl(hwnd_retro, K_ANIMPOSX, 0, 42, 16, "center")
AniGif_LoadGifFromFile(h_aniGifRetro, "manicminer.gif")
AniGif_SetBkColor(h_aniGifRetro, 0xFF00FF)
Gui,4:Hide

;BMW panel-1
Gui,New
Gui,5:+ToolWindow
Gui,5:Color,777700
Gui,5:Show,X0 Y0 H800 W800
WinSet, AlwaysOnTop, On, A
WinSet, Style, -0xC00000, A
WinSet, Transparent, %K_BMWTRANSPARENCY%, A
WinGet, bmwpanel1_ID, ID, A
Gui,5:Hide

;BMW panel-2
Gui,New
Gui,6:+ToolWindow
Gui,6:Color,777700
Gui,6:Show,X0 Y0 H800 W800
WinSet, AlwaysOnTop, On, A
WinSet, Style, -0xC00000, A
WinSet, Transparent, %K_BMWTRANSPARENCY%, A
WinGet, bmwpanel2_ID, ID, A
Gui,6:Hide

SetTimer, MainLoop, 30
; ^^ I use this another time to perform the interruption of the information film
calibrate()
return

MainLoop:
if (n_userBeingGivenInstruction || b_calibrationProgress)
{
	Sleep,30
	return
	; return if other parts are active
	; other parts should zero where appropriate so I can carry on
}
if (b_scanOn)
{
	scanY0 := scanY0 + 1
	midScanY0 := scanY0 + (K_SCANHEIGHT//2)
	if (midScanY0=midScreenY)
	{
		progressScanLine()
		; ^^ this is the line that actually actuates the actual change over
		; the change that happens at the middle of the screen
	}
	if (scanY0 > A_ScreenHeight)
	{
		scanY0 := -K_SCANHEIGHT
	}
}
n_oldCrosshairPaintDown_x := n_crosshairPaintDown_x
n_oldCrosshairPaintAcross_y := n_crosshairPaintAcross_y
MouseGetPos, n_crosshairPaintDown_x, n_crosshairPaintAcross_y  
if (b_crossOn)
{
	UnpaintPaintCrosshairAsNecessary(n_oldCrosshairPaintDown_x, n_oldCrosshairPaintAcross_y)
	; if you don't put in this line
	; then the script will think that you merely are worried about
	; mouse wheel movement
	if (b_scanOn)
		UnpaintPaintScanlineAsNecessary(n_oldCrosshairPaintDown_x, n_oldCrosshairPaintAcross_y)
}
if (0=Mod(n_mouseJoyWheelCounterInterrupt,n_mouseJoyWheelCounterinterruptFreq))
{
	if (n_mouseJoyWheelCounter < 50)
		n_mouseJoyWheelCounter++
	if (n_mouseJoyWheelCounter > 50)
		n_mouseJoyWheelCounter--
}
MouseWheelToRightJoyConverter(K_GTE, 0, K_LT, 13, n_mouseJoyWheelCounter, K_TEXTFLOWINGUP, K_SCROLLSPEEDMAX)
MouseWheelToRightJoyConverter(K_GTE, 13, K_LT, 25, n_mouseJoyWheelCounter, K_TEXTFLOWINGUP, K_SCROLLSPEEDALMOSTMAX)
MouseWheelToRightJoyConverter(K_GTE, 25, K_LT, 37, n_mouseJoyWheelCounter, K_TEXTFLOWINGUP, K_SCROLLSPEEDALMOSTSLOW)
MouseWheelToRightJoyConverter(K_GTE, 37, K_LT, 49, n_mouseJoyWheelCounter, K_TEXTFLOWINGUP, K_SCROLLSPEEDSLOW)
MouseWheelToRightJoyConverter(K_GTE, 50, K_LTE, 50, n_mouseJoyWheelCounter, 0, 0)
MouseWheelToRightJoyConverter(K_GT, 51, K_LTE, 61, n_mouseJoyWheelCounter, K_TEXTFLOWINGDOWN, K_SCROLLSPEEDSLOW)
MouseWheelToRightJoyConverter(K_GT, 61, K_LTE, 74, n_mouseJoyWheelCounter, K_TEXTFLOWINGDOWN, K_SCROLLSPEEDALMOSTSLOW)
MouseWheelToRightJoyConverter(K_GT, 74, K_LTE, 87, n_mouseJoyWheelCounter, K_TEXTFLOWINGDOWN, K_SCROLLSPEEDALMOSTMAX)
MouseWheelToRightJoyConverter(K_GT, 87, K_LTE, 100, n_mouseJoyWheelCounter, K_TEXTFLOWINGDOWN, K_SCROLLSPEEDMAX)
n_mouseJoyWheelCounterInterrupt += 1
mouseMovement_countdown()
return

WheelUp::
if (n_userBeingGivenInstruction>0)
	return
if (b_crossOn)
{
	; had to add this because if the user is wiggling the mouse around
	; while using the crosshair and then scrolls the cross can get a bit stuck
	if (!IConsiderYouStill())
	{
		notifyRightClickIsIffyByFlashing()
		return
	}
}
if (isInScrollbar())
{
	Send,{PgUp}
}
else
{
	if (b_calibrationProgress)
	{
		b_calibrationProgress = 0
		b_wheelConfirmedUp = 1
		return
	}
	properlySwitchCrosshairOff()
	n_mouseJoyWheelCounter -= 9
	; scrolling stopping abrupt gets the crosshair stuck
	if (tooMuchInTheMiddle())
		n_mouseJoyWheelCounter -= 9
	if (n_mouseJoyWheelCounter<0)
		n_mouseJoyWheelCounter=0
	mouseMovement_sethigh()
}
return

WheelDown::
if (n_userBeingGivenInstruction>0)
	return
if (b_crossOn)
{
	; had to add this because if the user is wiggling the mouse around
	; while using the crosshair and then scrolls the cross can get a bit stuck
	if (!IConsiderYouStill())
	{
		notifyRightClickIsIffyByFlashing()
		return
	}
}
if (isInScrollbar())
{
	Send,{PgDn}
}
else
{
	if (b_calibrationProgress)
	{
		b_calibrationProgress = 0
		b_wheelConfirmedDown = 1
		return
	}
	properlySwitchCrosshairOff()
	n_mouseJoyWheelCounter += 9
	; scrolling stopping abrupt gets the crosshair stuck
	if (tooMuchInTheMiddle())
		n_mouseJoyWheelCounter += 9
	if (n_mouseJoyWheelCounter>100)
		n_mouseJoyWheelCounter=100
	mouseMovement_sethigh()
}
return

q::
AniGif_DestroyControl(h_aniGifRetro) 
AniGif_DestroyControl(h_aniGifTheKeys)
AniGif_DestroyControl(h_aniGifAnnoyAdviceText)
SystemCursor("On")
If (b_taskbarHidden){
	WinShow, ahk_class Shell_TrayWnd
	WinShow, Start ahk_class Button
}
Gui,configInput:New
Gui,configInput:Add, Picture, w480 h240, seeYa.png
Gui,configInput:Color,FFFFFF
Gui,configInput:Show,AutoSize Center
WinSet, Style, -0xC00000, A
Sleep,1800
Gui,configInput:Hide
ExitApp
return

RButton::
if (n_userBeingGivenInstruction>0 || b_calibrationIsActiveAndOngoing)
	return
if (!IConsiderYouStill())
{
	notifyRightClickIsIffyByFlashing()
	return
}
if (!b_crossOn)
{
	if (b_scanOn)
	{
		iWouldLikeScanningToStop()
	}
	;show crosshair
	Gui,1:Show
	Gui,2:Show
	b_crossApparentlyOffButReallyStillOnscreen = 0
	b_crossOn = 1
}
else
{
	; enact the pseudo park / pseudo off behaviour
	; meaningthe cross hair is visible but the mouse can move without it
	b_crossApparentlyOffButReallyStillOnscreen = 1
	n_crossApparentlyOffButReallyStillOnscreen_x = %n_crosshairPaintDown_x%
	n_crossApparentlyOffButReallyStillOnscreen_y = %n_crosshairPaintAcross_y%
	notifyParkedByFlashing()
	b_crossOn = 0
	return
}
SeeIfMouseNeedsTurnOn()
return

c::
if (n_userBeingGivenInstruction>0 || b_calibrationIsActiveAndOngoing)
	return
if (!IConsiderYouStill())
	return
; force calibrate
calibrate()
return

MButton::
if (n_userBeingGivenInstruction>0 || b_calibrationIsActiveAndOngoing)
	return
if (!IConsiderYouStill())
	return
; scan on
b_scanCancel := 0
if (b_scanOn)
{
	iWouldLikeScanningToStop()
}
else
{
	n_BMWrotationCounter += 1
	iWouldLikeScanningToStart()
}
SeeIfMouseNeedsTurnOn()
return

p::
if (n_userBeingGivenInstruction>0 || b_calibrationIsActiveAndOngoing)
	return
if (!IConsiderYouStill())
	return
properlySwitchCrosshairOff()
return

SPACE::
if (n_userBeingGivenInstruction>0)
{
	n_userBeingGivenInstruction = 0
	b_spacePushedToForceTerminateAvatarGuy = 1
	return
}
;WinExist("ahk_class Shell_TrayWnd")
b_taskbarHidden := !b_taskbarHidden
If (b_taskbarHidden) {
	WinHide, ahk_class Shell_TrayWnd
	WinHide, Start ahk_class Button
} Else {
	WinShow, ahk_class Shell_TrayWnd
	WinShow, Start ahk_class Button
}
return

k::
if (n_userBeingGivenInstruction>0 || b_calibrationIsActiveAndOngoing || !b_scanOn)
	return
if (b_animShuffleHoldOn)
; ^^ note that this is the opposite of Shuffle
;    don't be a fool here and read it quickly do a Qamar with his VISA issue
{
	maintainThatSomethingShouldHaveHappen("Shuffle on")
	b_animShuffleHoldOn=0
}
else
{
	maintainThatSomethingShouldHaveHappen("Shuffle off")
	b_animShuffleHoldOn=1
}
return
